const mongoose = require('mongoose').set('debug', false)
const Schema = mongoose.Schema;

mongoose.Promise = global.Promise;
mongoose.level = "F";

const tools = require('../tools/general');

const { ObjectID } = require('mongodb');

// Resolving error Unknown modifier: $pushAll
mongoose.plugin(schema => {
  schema.options.usePushEach = true
});

const CatGrpSchema = new Schema({
  _id: {
    type: Number,
  },
  descr: {
    type: String,
  },
  idCatGrp: {
    type: Number
  },
  icon: {
    type: String,
  },
  img: {
    type: String,
  },
  color: {
    type: String,
  },
  theme: {
    type: String,
  },
});

CatGrpSchema.pre('save', async function (next) {
  if (this.isNew) {
    const myrec = await CatGrp.findOne().limit(1).sort({_id:-1});
    if (!!myrec) {
      if (myrec._doc._id === 0)
        this._id = 1;
      else
        this._id = myrec._doc._id + 1;
    } else {
      this._id = 1;
    }
  }

  next();
});

CatGrpSchema.statics.findAllIdApp = async function (idapp) {
  const CatGrp = this;

  const query = [
    { $sort: { descr: 1 } }
  ];

  return await CatGrp
    .aggregate(query)
    .then((arrrec) => {
      return arrrec
    })

};

CatGrpSchema.statics.getFieldsForSearch = function () {
  return [{ field: 'descr', type: tools.FieldType.string }]
};

CatGrpSchema.statics.executeQueryTable = function (idapp, params) {
  params.fieldsearch = this.getFieldsForSearch();
  return tools.executeQueryTable(this, 0, params);
};


const CatGrp = mongoose.model('CatGrp', CatGrpSchema);

module.exports = { CatGrp };
